define([
	'angular-ios9-uiwebview.patch',
	'ngStorage',
	'ngCordova',
	'chivoxPlugins',

	'controllers/index',
	'services/index',
	'directives/index',
	'filters/index'
], function() {
	return angular.module('starter', [
		'ngIOS9UIWebViewPatch',
		'ionic',
		'ngStorage',
		'ngCordova',
		'ngCordovaChivoxPlugins',

		'starter.controllers',
		'starter.services',
		'starter.directives',
		'starter.filters'
	], function($httpProvider) {
		// Use x-www-form-urlencoded Content-Type
		$httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
	 
			/**
			 * The workhorse; converts an object to x-www-form-urlencoded serialization.
			 * @param {Object} obj
			 * @return {String}
			 */
			var param = function(obj) {
			var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
				
			for(name in obj) {
				value = obj[name];
					
				if(value instanceof Array) {
					for(i=0; i<value.length; ++i) {
						subValue = value[i];
						fullSubName = name + '[' + i + ']';
						innerObj = {};
						innerObj[fullSubName] = subValue;
						query += param(innerObj) + '&';
					}
				}
				else if(value instanceof Object) {
					for(subName in value) {
						subValue = value[subName];
						fullSubName = name + '[' + subName + ']';
						innerObj = {};
						innerObj[fullSubName] = subValue;
						query += param(innerObj) + '&';
					}
				}
				else if(value !== undefined && value !== null)
					query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
			}
				
			return query.length ? query.substr(0, query.length - 1) : query;
		};
	 
		// Override $http service's default transformRequest
		$httpProvider.defaults.transformRequest = [function(data) {
			return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
		}];
	})

	.run(function($ionicPlatform, $rootScope, $state, $http, PlatformUtil, Teachers) {
		PlatformUtil.initRem();

		$ionicPlatform.ready(function() {
			PlatformUtil.init();

			// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
			// for form inputs)
			if(window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
			}
			if (window.plugins && window.plugins.orientationLock) {
				window.plugins.orientationLock.lock("portrait");
			}
			// ios7 list delete bug
			if (navigator.userAgent.match(/OS [7]_\d[_\d]* like Mac OS X/i)) { // ios7 bug
				$rootScope.ios7 = true;
			}

			window.umengAnalytics && umengAnalytics.init();
		})

		$rootScope.$on('$ionicView.beforeEnter', function() {
			if ($state.current.name === 'login' && Teachers.isLogin()) $state.go('tab.tasks');
			if ($state.current.name !== 'login' && $state.current.name !== 'guide' && !Teachers.isLogin()) $state.go('login');
			$rootScope.hideTabs = !!$state.current.hideTabs;
		})

		$rootScope.$on('$ionicView.afterEnter', function() {
			$rootScope.hideTabs = !!$state.current.hideTabs;
		})
	})

	.config(function($sceDelegateProvider, $ionicConfigProvider) {

		// 其余配置
		$sceDelegateProvider.resourceUrlWhitelist([
			// Allow same origin resource loads.
			'self',
			// Allow loading from our assets domain.  Notice the difference between * and **.
			'http://10.0.40.50/**'
		]);

		$ionicConfigProvider.platform.ios.tabs.style('standard'); 
		$ionicConfigProvider.platform.ios.tabs.position('bottom');
		$ionicConfigProvider.platform.android.tabs.style('standard');
		$ionicConfigProvider.platform.android.tabs.position('bottom');

		$ionicConfigProvider.platform.ios.navBar.alignTitle('center'); 
		$ionicConfigProvider.platform.android.navBar.alignTitle('center');

		$ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
		$ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');				

		$ionicConfigProvider.platform.ios.views.transition('ios'); 
		$ionicConfigProvider.platform.android.views.transition('android');

		$ionicConfigProvider.views.swipeBackEnabled(false);
	})
})
