define(['./module'], function(module) {

	module.controller('ChooseTopicCtrl', function($scope, $rootScope, $state, $stateParams, $ionicLoading, $timeout, $ionicPopup, $ionicHistory, $ionicScrollDelegate, Toast, Teachers, Resources, Tasks) {
		$scope.goBack = function() {
			$ionicHistory.goBack();
		}

		$scope.canGoNext = function() {
			if (taskTypeList.length == 0) {
				return false;
			}else{
				return true;
			}
		}

		/**
		 * 布置作业
		 */
		$scope.beganhomework = function() {
			if ($scope.canGoNext()) {
				Resources.setTaskTypeData(taskTypeList);
				Resources.setTasksMin($scope.tasksMin);
				Resources.setTasksNum($scope.tasksNum);
				$state.go('tab.assign');
			};
		}

		var unitId = Resources.getUnitSectionData().unitId;
		var sectionIdList = [];
		Resources.getUnitSectionData().sectionIdList.forEach(function(s) {
			sectionIdList.push(s.sectionId);
		});
		var tea = Teachers.get();
		var allRes;

		var taskTypeList = [];

		var resInfo = {
			isWordEmpty: true,
			isSentEmpty: true,
			isParaEmpty: true,
			isDialogEmpty: true
		};

		$scope.taskTypeInfo = [{
			name: '课前预习',
			selectNum: 0,
			id: 'gd'
		}, {
			name: '课后朗读',
			selectNum: 0,
			id: 'ld'
		}, {
			name: '听写训练',
			selectNum: 0,
			id: 'tx'
		}, {
			name: '背诵通关',
			selectNum: 0,
			id: 'bs'
		}];

		loadRes();

		function loadRes() {
			Tasks.getDetailByUnitId(tea.id, unitId, sectionIdList, tea.token).then(function(data) {
				allRes = data;

				disposeResInfo(data);
				disposeTaskTypeInfo();
			}, function(err) {
				$ionicPopup.confirm({
					title: '资源加载失败啦~<br>快去检查网络是否正常~',
					okText: '重新加载',
					cancelText: '知道啦'
				}).then(function(state) {
					if (state) {
						loadRes();	
					}
				})
			});
		}

		/**
		 * 全选或全不选
		 */
		$scope.selectAll = function(event, taskType, value) {
			var types = taskType.types;
			types.forEach(function(type) {
				type.checked = value;
				$("#" + type.type).prop("checked",  typeof value === 'undefined' ? false : value);
			});
			if (value) {
				taskType.selectNum = types.length;
			} else {
				taskType.selectNum = 0;
			}
			$scope.stopEvent(event);
			onChange();
		}


		/**
		 * 选中或取消选中单个题型
		 */
		$scope.selectOnly = function(taskType, type, value) {
			type.checked = value;
			
			if (value) {
				taskType.selectNum += 1;
				if (taskType.selectNum >= taskType.types.length) {
					$('#' + taskType.id).prop("checked", true);
				}
			}else{
				taskType.selectNum -= 1;
				if (taskType.selectNum < taskType.types.length) {
					$('#' + taskType.id).prop("checked", false);
				}
			}
			onChange();
		}

		$scope.getTaskTypeSelection = function(type) {
			return type.checked;
		}

		/**
		 * 阻止事件传递
		 */
		$scope.stopEvent = function(event) {
			event.stopPropagation();
		}

		$scope.toggle = function(taskType) {
			taskType.toggle = !taskType.toggle;
			$ionicScrollDelegate.resize();
		}

		$scope.isShown = function(taskType) {
			return taskType.toggle;
		}

		$scope.isShowItem = function(taskType) {
			if (!taskType.types) {
				return false;
			};
			if (taskType.types.length > 0) {
				return true;
			} else {
				return false;
			};
		}

		function disposeResInfo(data) {
			var info;
			sectionIdList.forEach(function(id) {
				info = data['sectionId_' + id];
				resInfo.isWordEmpty = resInfo.isWordEmpty && (info.word.length > 0? false:true);
				resInfo.isSentEmpty = resInfo.isSentEmpty && (info.sent.length > 0? false:true);
				resInfo.isParaEmpty = resInfo.isParaEmpty && (info.para.length > 0? false:true);
				resInfo.isDialogEmpty = resInfo.isDialogEmpty && (info.dialog.length > 0? false:true);
			});
		}


		function disposeTaskTypeInfo() {
			// 课前预习
			$scope.taskTypeInfo[0].types = [];
			if (!resInfo.isWordEmpty) {
				$scope.taskTypeInfo[0].toggle = true;
				$scope.taskTypeInfo[0].types.push({type: '1_gd', name: '单词跟读', pattern:'isWordEmpty', checked: false});
			};
			if (!resInfo.isSentEmpty) {
				$scope.taskTypeInfo[0].toggle = true;
				$scope.taskTypeInfo[0].types.push({type: '2_gd', name: '句子跟读', pattern:'isSentEmpty', checked: false});
			};
			if (!resInfo.isParaEmpty) {
				$scope.taskTypeInfo[0].toggle = true;
				$scope.taskTypeInfo[0].types.push({type: '3_gd', name: '段落跟读', pattern:'isParaEmpty', checked: false});
			};
			if (!resInfo.isDialogEmpty) {
				$scope.taskTypeInfo[0].toggle = true;
				$scope.taskTypeInfo[0].types.push({type: '4_gd', name: '对话跟读', pattern:'isDialogEmpty', checked: false});
			};
			

			// 课后朗读
			$scope.taskTypeInfo[1].types = [];
			if (!resInfo.isWordEmpty) {
				$scope.taskTypeInfo[1].toggle = true;
				$scope.taskTypeInfo[1].types.push({type: '1_ld', name: '单词朗读', pattern:'isWordEmpty', checked: false});
			};
			if (!resInfo.isSentEmpty) {
				$scope.taskTypeInfo[1].toggle = true;
				$scope.taskTypeInfo[1].types.push({type: '2_ld', name: '句子朗读', pattern:'isSentEmpty', checked: false});
			};
			if (!resInfo.isParaEmpty) {
				$scope.taskTypeInfo[1].toggle = true;
				$scope.taskTypeInfo[1].types.push({type: '3_ld', name: '段落朗读', pattern:'isParaEmpty', checked: false});
			};
			if (!resInfo.isDialogEmpty) {
				$scope.taskTypeInfo[1].toggle = true;
				$scope.taskTypeInfo[1].types.push({type: '4_ld', name: '对话朗读', pattern:'isDialogEmpty', checked: false});
			};
			

			// 听写训练
			$scope.taskTypeInfo[2].types = [];
			if (!resInfo.isWordEmpty) {
				$scope.taskTypeInfo[2].toggle = true;
				$scope.taskTypeInfo[2].types.push({type: '1_tx', name: '单词听写', pattern:'isWordEmpty', checked: false});
			};

			// 背诵通关
			$scope.taskTypeInfo[3].types = [];
			if (!resInfo.isParaEmpty) {
				$scope.taskTypeInfo[3].toggle = true;
				$scope.taskTypeInfo[3].types.push({type: '3_bs', name: '段落背诵', pattern:'isParaEmpty', checked: false});
			};
		}

		function onChange() {
			$scope.tasksNum = 0
			taskTypeList = [];
			var sumTime = 0;
			var section;
			for (var i = 0 ; i < $scope.taskTypeInfo.length; i++) {
				var taskType = $scope.taskTypeInfo[i];
				var ty = {};
				var types = [];
				ty.taskName = taskType.name;
				for (var j = 0; j < taskType.types.length; j++) {
					var type = taskType.types[j];
					if (type.checked) {
						var t = {};
						t.type = type.type;
						t.name = type.name;
						types.push(t);
					}
				}
				ty.types = types;
				if (ty.types.length > 0) {
					taskTypeList.push(ty);
				};
			}
			if (taskTypeList.length == 0) {
				$scope.tasksMin = 0;
				return;
			};
			taskTypeList.forEach(function(taskType) {
				taskType.types.forEach(function(type){
						if (type.type == '1_gd') {	// 单词跟读
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.word) {
								if (section.word.length > 0) {
									$scope.tasksNum++;
								};
								sumTime += Math.ceil((section.word.length / 6));
							};
						});
					} else if (type.type == '2_gd') {	// 句子跟读
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.sent) {
								if (section.sent.length > 0) {
									$scope.tasksNum++;
								};
								sumTime += Math.ceil((section.sent.length * 2 / 3));
							};
						});
					} else if (type.type == '4_gd') {	// 对话跟读
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.dialog) {
								var tempSentNum = 0;
								if (section.dialog.length > 0) {
									$scope.tasksNum++;
								};
								section.dialog.forEach(function(d) {
									tempSentNum += d.content.length;
								})
								sumTime += Math.ceil((tempSentNum * 2 / 3));
							};
						});
					} else if (type.type == '3_gd') {	// 段落跟读
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.para) {
								var tempWordNum = 0;
								if (section.para.length > 0) {
									$scope.tasksNum++;
								};
								section.para.forEach(function(p) {
									tempWordNum += p.content.trim().split(/\W+/).length;
								})
								sumTime += Math.ceil((tempWordNum / 60));
							};
						});
					} else if (type.type == '1_ld') {	// 单词朗读
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.word) {
								if (section.word.length > 0) {
									$scope.tasksNum++;
								};
								sumTime += Math.ceil((section.word.length / 12));
							};
						});
					} else if (type.type == '2_ld') {	// 句子朗读
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.sent) {
								if (section.sent.length > 0) {
									$scope.tasksNum++;
								};
								sumTime += Math.ceil((section.sent.length / 3));
							};
						});
					} else if (type.type == '4_ld') {	// 对话朗读
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.dialog) {
								var tempSentNum = 0;
								if (section.dialog.length > 0) {
									$scope.tasksNum++;
								};
								section.dialog.forEach(function(d) {
									tempSentNum += d.content.length;
								})
								sumTime += Math.ceil((tempSentNum / 3));
							};
						});
					} else if (type.type == '3_ld') {	// 段落朗读
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.para) {
								var tempWordNum = 0;
								if (section.para.length > 0) {
									$scope.tasksNum++;
								};
								section.para.forEach(function(p) {
									tempWordNum += p.content.trim().split(/\W+/).length;
								})
								sumTime += Math.ceil((tempWordNum / 120));
							};
						});
					} else if (type.type == '1_tx') {	// 单词听写
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.word) {
								if (section.word.length > 0) {
									$scope.tasksNum++;
								};
								sumTime += Math.ceil((section.word.length / 3));
							};
						});
					} else if (type.type == '3_bs') {	// 背诵
						sectionIdList.forEach(function(id) {
							section = allRes['sectionId_' + id];
							if (section && section.para) {
								var tempWordNum = 0;
								if (section.para.length > 0) {
									$scope.tasksNum++;
								};
								section.para.forEach(function(p) {
									tempWordNum += p.content.trim().split(/\W+/).length;
								})
								sumTime += Math.ceil((tempWordNum / 120) + (tempWordNum / 80));
							};
						});
					};
				});
			});
			if (sumTime > 1) {
				$scope.tasksMin = sumTime;
			} else {
				$scope.tasksMin = 1;
			};
		}
	})
})