define(['./module'], function(module) {

	module.controller('FeedbackCtrl', function($scope, $rootScope, $state, $stateParams, $ionicLoading, $ionicHistory, $timeout, Teachers, Feedback, Toast, PlatformUtil) {
		PlatformUtil.registerBackButtonAction(function(e) {
			return !!$scope.$apply(function() {
				if (window.cordova && window.cordova.plugins.Keyboard) {
					if (cordova.plugins.Keyboard.isVisible) {
						cordova.plugins.Keyboard.close();
					} else {
						$scope.goBack();
					};
				} else {
					$scope.goBack();
				}
			})
		})

		var tea = Teachers.get();
		var version = $stateParams.version;

		$timeout(function() {
			$('#feedback').focus();
		}, 1000)

		$scope.feedbackConf = function(e) {
			if (e.keyIdentifier == 'Enter') {
				// document.getElementById('contact').focus();
			}
		}

		$scope.contactConf = function(e, feedbackText, contactText) {
			if (e.keyIdentifier == 'Enter') {
				submitForm(feedbackText, contactText);
				document.getElementById('contact').blur();
			}
		}

		$scope.onFocusTextArea = function() {
			if (window.cordova && window.cordova.plugins.Keyboard) {
				if (!cordova.plugins.Keyboard.isVisible) {
					cordova.plugins.Keyboard.show();
				}
			}
		}

		$scope.goBack = function() {
			$ionicHistory.goBack();
		}

		$scope.submit = function(feedbackText, contactText) {
			submitForm(feedbackText, contactText);
		}

		// 提交意见反馈
		function submitForm(feedbackText, contactText) {
			if (!feedbackText) {
				$timeout(function() {
					$('#feedback').focus();
				}, 1000)
				Toast.show('请输入意见反馈');
				return;
			}
			if (!contactText) {
				$timeout(function() {
					$('#contact').focus();
				}, 1000)
				Toast.show('请输入联系方式');
				return;
			}
			if (/\D+/g.test(contactText)) {	// 如果含义非数字字符
				$timeout(function() {
					$('#contact').focus();
				}, 1000)
				Toast.show('请输入正确的联系方式，手机号或QQ号');
				return;
			}
			$ionicLoading.show({
				template: '<ion-spinner></ion-spinner><br/>正在提交，请稍候'
			});
			Feedback.addOneFeedback(tea.area_id, version, tea.id, tea.teacher_name, contactText, feedbackText, tea.token).then(function(data) {
				$ionicLoading.hide();
				Toast.show('上传成功');
				$scope.goBack();
			}, function(data) {
				$ionicLoading.hide();
				if (!data.status) {
					if (data.info) {
						Toast.show(data.info);
					} else {
						Toast.show('上传失败');
					};
					if (window.cordova && window.cordova.plugins.Keyboard) {
						cordova.plugins.Keyboard.close();
					}
				}
			});
		}
	})
})