define(['./module'], function(module) {
    module.controller('LoginCtrl', function($scope, $rootScope, $ionicLoading, $timeout, $state, $ionicPopup, Teachers, Toast, Config) {
        $scope.user = {
            username: '',
            password: ''
        }
        $scope.errMsg = null;
        $scope.succTip = null;
        $scope.loaded = false;

        var actived = false,
            activation = false;
        $scope.$on('modal.shown', function() {
            $('.actbox').on('webkitAnimationIteration', '.loading', function() {
                if (actived) {
                    $(this).remove();

                    $scope.$apply(function() {
                        $scope.loaded = true;
                        $scope.succ = activation;
                        $scope.fail = !activation;
                    })
                }
            })
            Teachers.activate().then(function(state) {
                actived = true;
                activation = state;

                if (Teachers.isLoggedBefore($scope.user))
                    $scope.succTip = '登录成功';
                else
                    $scope.succTip = '激活成功';

                Teachers.logged($scope.user);

                $timeout(function() {
                    $scope.goHome();
                }, 3000)
            }, function(err) {
                Teachers.reset();
                actived = true;
                activation = false;
                $scope.errMsg = err;
            });
        })
        $scope.$on('modal.hidden', function() {
            $timeout(function() {
                $scope.loaded = false;
                $scope.succ = false;
                $scope.fail = false;
                $scope.errMsg = null;
                actived = false;
                activation = false;
            }, 500)
        })

        $scope.relogin = function() {
            $scope.scoreModal.hide();
        }
        $scope.goHome = function() {
            if ($scope.succ) {
                $scope.scoreModal.hide();
                $state.go('tab.tasks');
            }
        }
        $scope.showDisclaimer = function() {
            $ionicPopup.alert({
                title: '免责声明',
                template: Config.disclaimer,
                okText: '我知道了'
            });
        }

        // 登录
        $scope.userConf = function(e) {
            if (e.keyIdentifier == 'Enter') {
                document.getElementById('pass').focus();
            }
        }
        $scope.passConf = function(e, user) {
            if (e.keyIdentifier == 'Enter') {
                submitForm(user);
                document.getElementById('pass').blur();
            }
        }
        $scope.submit = function(user) {
            submitForm(user);
        }

        function submitForm(user) {
            if (!user) {
                Toast.show('请输入用户名和密码');
                return;
            }
            if (!user.username) {
                $timeout(function() {
                    $('#username').focus();
                }, 1000)
                Toast.show('请输入用户名');
                return;
            }
            if (!user.password) {
                $timeout(function() {
                    $('#pass').focus();
                }, 1000)
                Toast.show('请输入密码');
                return;
            }
            $ionicLoading.show({
                template: '<ion-spinner></ion-spinner><br/>正在登录，请稍候'
            });

            var params = {username : user.username,
                        password : user.password};

            Teachers.preLoad(params).then(function(data) {
                console.log(data);
                if (data) {
                    Config.host = data.CustomerInfo.zy_url;
                    Config.httpUrl = data.CustomerInfo.mobile_url;
                    Config.httpUploadUrl = data.CustomerInfo.zy_url + '/receiveApkAudioZip/uploadAudioZip.php';
                    console.log('Config.host', Config.host);

                    Teachers.login(user).then(function(data) {
                        $ionicLoading.hide();

                        Teachers.save(data.data);
                        Teachers.saveUser(user);
                        Teachers.setLoginedManually(true);
                        $rootScope.$emit('System:login');
                        $state.go('tab.tasks');
                    }, function(data) {
                        $ionicLoading.hide();
                        console.log('--------login error--------', data)
                        if (data.status === -1) {
                            $timeout(function() {
                                $ionicPopup.alert({
                                    title: '登录失败',
                                    template: '<div style="text-align: center">用户名或密码错误</div>',
                                    okText: '我知道了'
                                })
                            }, 300);
                        }
                    });
                } else {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: '登录失败',
                        template: '<div style="text-align: center">用户名或密码错误</div>',
                        okText: '我知道了'
                    })
                        if (window.cordova && window.cordova.plugins.Keyboard) {
                            cordova.plugins.Keyboard.close();
                     }
                }
            }, function(data) {
                $ionicLoading.hide();
                console.log('--------login error--------', data);
                if (data.status === -1) {
                    $ionicPopup.alert({
                        title: '登录失败',
                        template: '<div style="text-align: center">用户名或密码错误</div>',
                        okText: '我知道了'
                    })
                        if (window.cordova && window.cordova.plugins.Keyboard) {
                            cordova.plugins.Keyboard.close();
                     }
                }
            });
        }
    })
})