define(['./module'], function(module) {

	module.controller('NoticesCtrl', function($scope, $rootScope, $state, $timeout, $ionicLoading, $ionicPopup, $ionicHistory, Notices, Config, Teachers, Toast) {
		$ionicHistory.clearHistory();

		var tea = Teachers.get();
		$scope.notices = [];

		$rootScope.$emit('Notice:update');

		$scope.doRefresh = function() {
			page = 1;
			Notices.getTeaNoticesByPage(tea.id, page, Config.row, tea.token).then(function(notices) {
				page++;
				checkMoreData(notices);
				$scope.notices = notices;
				loaded = true;
				$scope.show404 = networkError = false;
				$scope.$broadcast('scroll.refreshComplete');
				$rootScope.$emit('Notice:update');
			}, function(err) {
				loaded = true;
				$scope.show404 = networkError = true;
				$scope.$broadcast('scroll.refreshComplete');
				// Toast.show(Config.timeoutTip);
			});
		}

		// 切换tab，请求第一页
		$scope.init = function() {
			// TODO loading统一由服务处理
			$ionicLoading.show({
				template: '<ion-spinner></ion-spinner><br/>加载中...'
			})
			Notices.getTeaNoticesByPage(tea.id, page, Config.row, tea.token).then(function(notices) {
				page++;
				checkMoreData(notices);
				$scope.notices = notices;
				loaded = true;
				$scope.show404 = networkError = false;
				$ionicLoading.hide();
			}, function(err) {
				loaded = true;
				$scope.show404 = networkError = true;
				$ionicLoading.hide();
				// Toast.show(Config.timeoutTip);
			});
		}
		var loaded = false;	// 是否有网络请求完成
		$scope.hasNoData = function() {
			return loaded && !$scope.notices.length && !networkError;
		}

		// 无限滚动--分页
		var page = 1;
		var hasMoreData = true;
		var networkError = false;
		$scope.show404 = false;

		$scope.moreDataCanBeLoaded = function() {
			return loaded && hasMoreData && !networkError;
		}

		$scope.getHref = function(notice) {
			if (notice.msgType != "notice") {	// 作业消息
				$state.go('tab.overview', {
					worksetId: notice.worksetId,
					scId: notice.scId,
					className: notice.className
				});
			} else if (notice.msgType == "notice") {	// 系统公告
				$state.go('tab.notice', {
					id: notice.id,
					jpush: 0,
					isRead: notice.isRead
				});
			}
		}

		$scope.getNoticeType = function(type) {
			var noticeType = null;
			type.forEach(function(t){
				var n = null;
				if (t == 'gd') {
					n = '课前预习';
				}else if (t == 'ld') {
					n = '课后朗读';
				}else if (t == 'tx') {
					n = '听写训练';
				}else if (t == 'bs') {
					n = '背诵通关';
				}

				if (noticeType != null) {
					noticeType = noticeType + '+' + n;
				}else{
					noticeType = n;
				}
			})
			return noticeType;
		}

		$scope.getSectionName = function(sectionName){
			var name = '';
			sectionName.forEach(function(c) {
				name += c;
				name += '   ';
			});
			if (name == '') {
				return name;
			};
			name = name.substr(0, name.length - 3);
			return name;
		} 

		$scope.loadMore = function() {
			Notices.getTeaNoticesByPage(tea.id, page, Config.row, tea.token).then(function(notices) {
				page++;
				checkMoreData(notices);
				$scope.notices = $scope.notices.concat(notices);
				loaded = true;
				$scope.show404 = networkError = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');	// 加载更多完成
			}, function(err) {
				loaded = true;
				$scope.show404 = networkError = true;
				$scope.$broadcast('scroll.infiniteScrollComplete');	// 加载更多完成
				// Toast.show(Config.timeoutTip);
			});
		}

		function checkMoreData(data) {
			if (data.length < Config.row) hasMoreData = false;
			else hasMoreData = true;
		}

		$scope.retry = function() {
			$scope.init();
		}

		// 全部设为已读
		$scope.readAll = function() {
			$ionicPopup.confirm({
				template: '将全部消息设为已读？',
				okText: '确定',
				cancelText: '取消'
			}).then(function(state) {
				if (state) {
					Notices.setAllNoticeReadedByTeacherId(tea.id, tea.token).then(function(data) {
						$scope.notices.forEach(function(notice) {
							if (notice.isRead != 1) {
								notice.isRead = 1;
							}
						})
						$rootScope.noticeNum = 0;
					});
				}
			})
		}
	})
})