define(['./module'], function(module) {

	module.controller('SettingsCtrl', function($scope, $rootScope, $state, $ionicHistory, $ionicLoading, $ionicPopup, $timeout, Teachers, MobileVersions, Config, Toast /*, chivoxFileTransfer*/ ) {
		$scope.cacheSize = 0;
		$scope.version = '';
		$scope.username = Teachers.get().teacher_name;
		$scope.schname = Teachers.get().school_name;

		if (!$rootScope.ios_switch) {
			$scope.ios_switch = device.platform == 'iOS' ? 0 : 1;
		} else {
			$scope.ios_switch = device.platform == 'iOS' ? $rootScope.ios_switch : 1;
		}

		// $rootScope.$emit('System:update');

		// chivoxFileTransfer.getDirTotalSize(chivoxFileTransfer.getAppRootDir()).then(function(totalSize) {
		// 	$scope.cacheSize = totalSize;
		// });

		cordova.getAppVersion(function(version) {
			$scope.version = version;
			$scope.$apply();
		});

		// $scope.clearCache = function() {
		// 	$ionicLoading.show({
		// 		template: '<ion-spinner></ion-spinner><br/>清理中...'
		// 	})
		// 	$ionicHistory.clearCache();
		// 	chivoxFileTransfer.clearCache().then(function() {
		// 		$ionicLoading.hide();
		// 		$scope.cacheSize = 0;
		// 	}, function(err) {
		// 		$timeout(function() {
		// 			$ionicLoading.hide();
		// 		});
		// 	});
		// }
		$scope.showDisclaimer = function() {
			$ionicPopup.alert({
				title: '免责声明',
				template: Config.disclaimer,
				okText: '我知道了'
			});
		}
		$scope.download = function() {
			if (!$rootScope.newVersion) {
				Toast.show(Config.latestVersion);
				return;
			}

			$ionicLoading.show({
				template: '<ion-spinner></ion-spinner><br/>正在获取新版本'
			})
			MobileVersions.getVersion().then(function(data) {
				cordova.getAppVersion(function(version) {
					$ionicLoading.hide();
					console.log('version', data, version)

					var v = device.platform == 'iOS' ? data.ios_version : data.version;
					var updateUrl = device.platform == 'iOS' ? data.ios_url : data.android_url;

					if (v > version) { // 线上版本大于当前版本
						cordova.InAppBrowser.open(updateUrl, '_system', 'location=no');
					}
				})
			}, function() {
				$ionicLoading.hide();
				// Toast.show('更新失败，请稍后重试');
			});
		}
		$scope.feedback = function() {
			$state.go('tab.feedback', {
				version: $scope.version
			});
		}
		$scope.logout = function() {
			$ionicPopup.confirm({
				title: '提示',
				template: '确认退出登录？',
				okText: '确定',
				cancelText: '取消'
			}).then(function(state) {
				if (state) {
					Teachers.logout();
					$ionicHistory.clearCache();
					$ionicHistory.clearHistory();
					$state.go('login');
				}
			})
		}
	})
})