define(['./module'], function(module) {

	module.controller('StudentCtrl', function($scope, $state, $rootScope, $cvActionSheet, $ionicLoading, $ionicHistory, $ionicPopup, $ionicPosition, $ionicBackdrop, $stateParams, PlatformUtil, Tasks, Teachers, Toast, Config) {
		// $ionicHistory.clearHistory();
		
		$scope.toggleTask = function(task) {
			task.toggle = !task.toggle;
			$ionicScrollDelegate.resize();
		}

		$scope.isDetailShown = function(task) {
			return task.toggle;
		}
		$scope.showScore = function(content) {
			if (typeof content.score != 'undefined') {
				return true;
			} else {
				return false;
			};
		}

		$scope.getContentScore = function(content) {
			if (typeof content.score == 'undefined') {
				return 0;
			} else {
				return content.score;
			};
		}

		$scope.getScoreLevel = function(score) {
			if (typeof score == 'undefined') {
				return 'bad';
			}
			if (score < 55) return 'bad';
			else if (score < 70) return 'medium';
			else return 'good';
		}

		$scope.isLastTaskInSection = function(task, taskList) {
			if (task == taskList[taskList.length - 1]) {
				return true;
			} else {
				return false;
			};
		}


		var tea = Teachers.get();
		var wsId = $stateParams.wsId;
		var stuId = $stateParams.stuId;
		var titleHeightRem = 0.88;
		if (device.platform == 'iOS') {
			titleHeightRem = 1.28;
		}
		var sectionTitleDomHeight = 0.8 * (window.innerWidth / 7.5);	// sectionTitle的高度
		var titleHeight = titleHeightRem * (window.innerWidth / 7.5);	// 标题栏的高度

		$ionicLoading.show({
			template: '<ion-spinner></ion-spinner><br/>加载中...'
		});
		Tasks.getDetailReportByStuIdWSId(tea.id, wsId, stuId, tea.token).then(function(data) {
			data.sectionReport.forEach(function(sections){
				sections.taskReportList.forEach(function(section){
					section.toggle = true;
				});
			});
			$scope.student = data;
			$scope.scoreStatus = avgScoreStatus(data.worksetReport.avgScore);
			$ionicLoading.hide();
		}, function(err) {
			$ionicLoading.hide();
			// Toast.show(Config.timeoutTip);
		});

		$scope.isIOS = false;
		if (window.device && device.platform == 'iOS') {
			$scope.isIOS = true;
		}

		function avgScoreStatus(score) {
			if (score == '-' || score < 55) return 'bad';
			else if (score < 70) return 'medium';
			else return 'good';
		}

		$scope.goBack = function() {
			$ionicHistory.goBack();
		}

		$scope.onScroll = function() {
			$(".section-area").each(function() {
				var result = $ionicPosition.offset(angular.element(this));
				if (result.top < titleHeight) {
					$("#float-" + this.id).css({
						display: 'inherit'
					});
					$('.section-float-title').css({
						'top'  : (result.height + (result.top - titleHeight) < sectionTitleDomHeight) 
						? (sectionTitleDomHeight - (result.top + result.height)) * -1 
						: titleHeightRem + 'rem'
					});
				} else {
					$("#float-" + this.id).css({
						display: 'none'
					});
				}
			});
		}
	})
})