define(['./module'], function(module) {

	module.controller('TabCtrl', function($scope, $ionicPlatform, $rootScope, $state, $ionicHistory, $ionicPopup, $timeout, Teachers, Notices, PlatformUtil, MobileVersions, chivoxJPush, Config) {
		$ionicPlatform.ready(function() {
			// 在tab初始化完成之后初始化极光推送
			chivoxJPush.initPush();
			// chivoxJPush.setAlias(Config.teacherId + Teachers.get().id);
			// chivoxJPush.setTags([Config.areaId + Teachers.get().area_id]);
			// window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
		})

		var preLoad = Teachers.getPreLoad();

		$rootScope.$on('Notice:update', updateNotice)
		$rootScope.$on('System:update', checkUpdate)
		$rootScope.$on('System:login', onlogin)

		$rootScope.$on('jpush.openNotification', function(e, msg) {
			if (msg.extra.jtype == 'notice') {
				updateNotice();
				$ionicHistory.clearCache()
				if (msg.extra.jdata.type == 'task') {	// 作业消息
					$timeout(function() {
						$state.go('tab.notices');
					}, 200);
				} else if (msg.extra.jdata.type == 'notice') {	// 系统公告
					$state.go('tab.notice', {
						id: msg.extra.jdata.id,
						jpush: 1,	// 表明为用户直接点击推送信息
						isRead: 0	// 0表示未读
					})
				}
				
			}
		})
		
		$rootScope.$on('jpush.receiveNotification', function(e, msg) {
			if (msg.extra.jtype == 'notice') {
				updateNotice()
			}
		})

		$scope.initLayout = function() {
			// updateNotice()
			// checkUpdate()
			if (Teachers.isLoginedManually()) {
				Teachers.setLoginedManually(false);	// 该状态已经没有意义了，设为false
				return;	// 如果手动登录了，就不再自动登录了
			}
			loginAuto();
			onlogin();
			checkUpdate();
		}

		function updateNotice() {
			var tea = Teachers.get()
			Notices.getNoticeStatus(tea.id, tea.token).then(function(data) {
				console.log(data)
				$rootScope.noticeNum = data.num;
			})
		}

		function checkUpdate() {
			MobileVersions.getVersion().then(function(data) {
				var remote_version = device.platform == 'iOS' ? data.ios_version : data.version;
				var updateUrl = device.platform == 'iOS' ? data.ios_url : data.android_url;
				cordova.getAppVersion(function(version) {
					if (remote_version > version) {
						$rootScope.newVersion = true;
						$ionicPopup.confirm({
							title: '版本更新',
							template: '升级新版，享受更好的体验！',
							okText: '立即升级',
							cancelText: '下次再说'
						}).then(function(state) {
							if (state) {
								cordova.InAppBrowser.open(updateUrl, '_system', 'location=no');
							}
						})
					}
				})
			})
		}

		function onlogin() {
			var preLoad = Teachers.getPreLoad();
			var customerid = '0';
			if (preLoad && preLoad.CustomerInfo && preLoad.CustomerInfo.id) {
				customerid = preLoad.CustomerInfo.id;
			};
			chivoxJPush.setAlias(Config.pre + Config.customerid + customerid + '_' + Config.teacherId + Teachers.get().id);
			chivoxJPush.setTags([Config.pre + Config.customerid + customerid + '_' + Config.areaId + Teachers.get().area_id]);
			updateNotice();
			window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
		}

		function loginAuto() {	// 自动登录，为了能自动刷新线上信息，以防换班等情况
			var user = Teachers.getUser();
			Config.host = preLoad.CustomerInfo.zy_url;
            Config.httpUrl = preLoad.CustomerInfo.mobile_url;
            Config.httpUploadUrl = preLoad.CustomerInfo.zy_url + '/receiveApkAudioZip/uploadAudioZip.php';

			Teachers.login(user).then(function(data) {
				Teachers.save(data.data);
				onlogin()
				// 以下代码没有什么作用，teacherId与areaId都是固定不变的，不会随着换班而变化
				// chivoxJPush.setAlias(Config.teacherId + Teachers.get().id);
				// chivoxJPush.setTags([Config.areaId + Teachers.get().area_id]);
			}, function(data) {
				console.log('--------login auto error--------', data)
			})
		}
	})
})