define(['./module'], function(module) {

	module.controller('TaskCtrl', function($scope, $state, $rootScope, $ionicModal, $cvActionSheet, $stateParams, $ionicLoading, $ionicHistory, $ionicPosition, $ionicPopup, $ionicBackdrop, $timeout, $ionicScrollDelegate, $ionicPopover, PlatformUtil, Tasks, Teachers, Toast, Config, chivoxDatePicker) {
		$scope.toggleTask = function(task) {
			task.toggle = !task.toggle;
			$ionicScrollDelegate.resize();
		}

		$scope.isDetailShown = function(task) {
			return task.toggle;
		}
		$scope.getDetailArray = function(taskStr) {
			return JSON.parse(taskStr);
		}

		$scope.getScoreLevel = function(content) {
			var score = 0;
			if (typeof content.score != 'undefined' || content.score == '-') {
				score = content.score;
			}else{
				return 'noscore';
			}
			if (score < 55) return 'bad';
			else if (score < 70) return 'medium';
			else return 'good';
		}


		$scope.type = 2;
		$scope.scoreStatus = ['noscore', 'excellent', 'good', 'failure'];
		$scope.canUpdateDate = false;

		$scope.confirmTask = function() {
			Tasks.claimWorksets(tea.id, worksetId, tea.token).then(function(date) {
				Toast.show('认领成功!');
				$scope.task.status = 'doing';
				$ionicScrollDelegate.resize();
			},function(err){
				Toast.show('认领失败!');
			});
			
		}

		$scope.ignoreTask = function() {
			$ionicPopup.confirm({
				title: '确认忽略该作业？',
				template: '忽略后将不再推荐给未做的学生',
				okText: '确定',
				cancelText: '取消'
			}).then(function(state) {
				if (state) {
					Tasks.canceWorksets(tea.id, worksetId, tea.token).then(function() {
						$scope.goBack();
					});
				}
			})
		}

		$scope.getHref = function(task) {
			if ('tab.task' == $state.current.name) {	// 作业tab
				$state.go('tab.grade', {
					worksetId: worksetId,
					scId: scId
				});
			} else if ('tab.overview' == $state.current.name) {	// 消息tab
				$state.go('tab.overview-grade', {
					worksetId: worksetId,
					scId: scId
				});
			}
		}

		$ionicModal.fromTemplateUrl('tmpl/tasks/taskdeleted.html', {
			scope: $scope,
			hardwareBackButtonClose: true
		}).then(function(modal) {
			$scope.taskdeletedmodel = modal;
		});

		$scope.prompt = function() {
			if ($scope.taskdeletedmodel) {
				$scope.taskdeletedmodel.show();
			};
		}

		$scope.hidetaskdeletedModal = function() {
			if ($scope.taskdeletedmodel) {
				$scope.taskdeletedmodel.hide();
			};
		}
		
		$scope.goBack = function() {
			$ionicHistory.goBack();
		}

		$scope.getMonth = function(date) {
			if (typeof date == 'undefined') return;
			var monthArray = [1,2,3,4,5,6,7,8,9,10,11,12];
			var d = new Date(Date.parse(date));
			return monthArray[d.getMonth()] + '月' + d.getDate() + '日'; 
		}

		$scope.getWeek = function(date) {
			if (typeof date == 'undefined') return;
			var dayArray = ['周日','周一','周二','周三','周四','周五','周六'];
			var d = new Date(Date.parse(date));
			return dayArray[d.getDay()]; 
		}

		$scope.isLastTaskInSection = function(task, taskList) {
			if (task == taskList[taskList.length - 1]) {
				return true;
			} else {
				return false;
			};
		}

		var tea = Teachers.get();
		var worksetId = $stateParams.worksetId;
		var scId = $stateParams.scId;
		$scope.className = $stateParams.className;
		var expire_time;
		var titleHeightRem = 0.88;
		if (device.platform == 'iOS') {
			titleHeightRem = 1.28;
		}
		var sectionTitleDomHeight = 0.8 * (window.innerWidth / 7.5);	// sectionTitle的高度
		var titleHeight = titleHeightRem * (window.innerWidth / 7.5);	// 标题栏的高度

		$ionicLoading.show({
			template: '<ion-spinner></ion-spinner><br/>加载中...'
		});
		Tasks.getSCReportBySCIdWSId(tea.id, scId, worksetId, tea.token).then(function(data) {

			data.sectionReport.forEach(function(sections){
				sections.taskReportList.forEach(function(section){
					section.toggle = true;
				});
			});
			$scope.task = data;
			$ionicLoading.hide();

			expire_time = $scope.task.expiredDate;

			var style = '';
			if (data.avgScoreStatus == 2) style = 'yellow';
			else if (data.avgScoreStatus == 3) style = 'red';

			$scope.avgData = {
				title: '平均成绩',
				value: '<span class="'+ style +'">' + data.avgScore + '</span>',
				data: [{
					name: '良好',
					value: data.goodScoreNum,
					color: '#6BD172'
				}, {
					name: '合格',
					value: data.normalScoreNum,
					color: '#F5C711'
				}, {
					name: '较差',
					value: data.badScoreNum,
					color: '#ff5f21'
				}]
			}
			if (data.avgScore == '-') {
				$scope.avgData.nodata = true;
			}

			$scope.submitData = {
				title: '提交率',
				value: '<span style="color: #8BC34A">' + data.submitNum + '</span>/' + (data.submitNum + data.unSubmitNum),
				data: [{
					name: '未提交',
					value: data.unSubmitNum,
					color: '#C1E795'
				}, {
					name: '已提交',
					value: data.submitNum,
					color: '#8BC34A'
				}]
			}
			if (data.totalStuNum == 0) {
				$scope.submitData.nodata = true;
			}
		}, function(err) {
			$ionicLoading.hide();
			$ionicPopup.alert({
							title: '提示',
							template: err.info,
							okText: '好的'
						}).then(function(state) {
							$ionicHistory.goBack();
						})
		});

		$scope.onScroll = function() {
			$(".section-area").each(function() {
				var result = $ionicPosition.offset(angular.element(this));
				if (result.top < titleHeight) {
					$("#float-" + this.id).css({
						display: 'inherit'
					});
					$('.section-float-title').css({
						'top'  : (result.height + (result.top - titleHeight) < sectionTitleDomHeight) 
						? (sectionTitleDomHeight - (result.top + result.height)) * -1 
						: titleHeightRem + 'rem'
					});
				} else {
					$("#float-" + this.id).css({
						display: 'none'
					});
				}
			});
		}

	})
})