define(['./module'], function(module) {

	module.controller('TasksCtrl', function($scope, $state, $rootScope, $cvActionSheet, $ionicLoading, $ionicHistory, $ionicPopup, $ionicScrollDelegate, $ionicModal, PlatformUtil, Tasks, Teachers, Resources, Toast, Config, chivoxJPush) {
		// PlatformUtil.showStatusBar();

		$ionicHistory.clearHistory();

		// KeepScreenOn.removeKeepScreenOnStatus();

		$rootScope.$emit('Notice:update');

		var tea = Teachers.get();
		var loaded = false;
		var allClass = 0;	// 表示全部班级
		// 无限滚动--分页
		var page = 1;
		var hasMoreData = true;
		var networkError = false;
		$scope.tasks = [];
		$scope.show404 = false;
		$scope.taskType = 'all';
		$scope.currClassName = '全部';
		var currClass = allClass;

		if (Teachers.isLoginedManually()) {	// 保证退出登录之后，直接切换别的老师账号登录能成功推送
			chivoxJPush.setAlias(Config.teacherId + Teachers.get().id);
			chivoxJPush.setTags([Config.areaId + Teachers.get().area_id]);
		}

		// Resources.getSCInfoByTeaId(tea.id, tea.token).then(function(data) {
		// 	$scope.grades = data;
		// }, function(err) {
		// 	$scope.grades = [];
		// })

		$scope.init = function() {
			$ionicLoading.show({
				template: '<ion-spinner></ion-spinner><br/>正在加载作业列表'
			});

			Resources.getSCInfoByTeaId(tea.id, tea.token).then(function(data) {
				$scope.grades = data;
				if (Tasks.taskCache.currClass) {
					currClass = Tasks.taskCache.currClass;
					$scope.currClassName = Tasks.taskCache.currClassName;
				}
				if (Tasks.taskCache.taskType) {
					$scope.taskType = Tasks.taskCache.taskType;
				}

				$ionicScrollDelegate.resize();
				$ionicScrollDelegate.scrollTop();

				page = 1;
				loaded = false;

				Tasks.getTaskListBySCId(tea.id, getSCIdList(), $scope.taskType, page, Config.row, tea.token).then(function(data) {
					page++;
					checkMoreData(data);
					$ionicLoading.hide();
					$scope.ungroupdata = data;
					$scope.tasks = groupTask(data);
					$scope.show404 = networkError = false;
					loaded = true;
				}, function(err) {
					$scope.show404 = networkError = true;
					$ionicLoading.hide();
					// Toast.show(Config.timeoutTip);
				});
			}, function(err) {
				$scope.grades = [];
				$ionicLoading.hide();
			})
		}

		$scope.changeTaskType = function(taskType) {
			Tasks.taskCache.taskType = taskType;
			$scope.taskType = taskType;
			$scope.init();
		}

		$scope.changeClass = function(e) {
			console.log('e', e)
			console.log('changeClass')
			var classes = getSCNameList();
			$cvActionSheet.show({
				buttons: classes,
				buttonClicked: function(index) {
					if (index) {
						currClass = classes[index].scId;
						$scope.currClassName = classes[index].text;
					} else {
						currClass = allClass;
						$scope.currClassName = '全部';
					};
					// 保存班级
					Tasks.taskCache.currClass = currClass;
					Tasks.taskCache.currClassName = $scope.currClassName;
					$scope.init();
					return true;
				}
			});
		}

		$scope.hasNoTaskClass = function() {
			if (loaded && !$scope.tasks.length && !networkError) {
				return 'no-' + $scope.taskType;
			}
			return null;
		}

		$scope.noTaskJumpAll = function() {
			if ($scope.taskType != 'all' && !!$scope.hasNoTaskClass()) {
				$scope.changeTaskType('all');
			}
		}

		$scope.totalNum= function(task){
			return parseInt(task.submitNum) + parseInt(task.unSubmitNum);
		}

		// 下拉刷新
		$scope.doRefresh = function() {
			page = 1;
			Tasks.getTaskListBySCId(tea.id, getSCIdList(), $scope.taskType, page, Config.row, tea.token).then(function(data) {
				page++;
				checkMoreData(data);
				$scope.ungroupdata = data;
				$scope.tasks = groupTask(data);
				$scope.$broadcast('scroll.refreshComplete');
				$scope.show404 = networkError = false;
			}, function(err) {
				// Toast.show(Config.timeoutTip);
				$scope.show404 = networkError = true;
				$scope.$broadcast('scroll.refreshComplete')
			})
		}

		/**
		 * 按照日期分组
		 */
		function groupTask(data) {
			var tasks = [];
			var temp = {}
			var key = null;
			data.forEach(function(item) {
				key = item.showDate;
				if (item.avgScore == '-') {
					item.scoreLevel = 'no-score';
				} else {
					item.scoreLevel = Config.getScoreLevel(item.avgScore);
				};
				if (item.status == Config.taskStatus.done) {
					item.scoreLevel += ' ';
					item.scoreLevel += Config.taskStatus.done;
				};
				if (temp[key]) {
					temp[key].data.push(item);
				} else {
					temp[key] = {
						showDate: item.showDate,
						data: [item]
					};
					tasks.push(temp[key]);
				}
			});
			console.log('tasks.....', tasks);
			return tasks;
		}

		/**
		 * 得到班级id
		 */
		function getSCIdList() {
			var cls = [];
			if (currClass == allClass) {
				cls.push('all');
			} else {
				$scope.grades.forEach(function(grade) {
					grade.scList.forEach(function(c) {
						if (c.scId == currClass) {
							cls.push(c.scId);
						};
					})
				})
			}
			return cls.join(',');
		}

		function getSCNameList() {
			var cls = [];
			var allcls = {text: '全部'};
			cls.push(allcls);

			if (currClass == allClass) allcls.selected = true;
			$scope.grades.forEach(function(grade) {
				grade.scList.forEach(function(item) {
					var c = {
						text: '<div>' + grade.cgyName + item.scName + '</div>'
					};
					c.scId = item.scId;
					if (item.scId == currClass) c.selected = true;
					cls.push(c);
				})
			});
			return cls;
		}

		$scope.moreDataCanBeLoaded = function() {
			return loaded && hasMoreData && !networkError;
		}

		$scope.loadMore = function() {
			Tasks.getTaskListBySCId(tea.id, getSCIdList(), $scope.taskType, page, Config.row, tea.token).then(function(data) {
				page ++;
				checkMoreData(data);
				$scope.ungroupdata = $scope.ungroupdata.concat(data);
				$scope.tasks = groupTask($scope.ungroupdata);
				$scope.$broadcast('scroll.infiniteScrollComplete')
				networkError = false;
			}, function(err) {
				networkError = true;
				// Toast.show(Config.timeoutTip);
				$scope.$broadcast('scroll.infiniteScrollComplete')
			})
		}

		function checkMoreData(data) {
			console.log('data.........', data)
			if (data.length < Config.row) hasMoreData = false;
			else hasMoreData = true;
		}

		function getClassesInfo() {
			Resources.getSCInfoByTeaId(tea.id, tea.token).then(function(data) {
				$scope.grades = data;
				if (!data || data.length <= 0) {
					if ($scope.noclassModal) {
						$scope.noclassModal.show();
					};
				} else {
					var scIdList = [];
					data.forEach(function(grade) {
						grade.scList.forEach(function(c) {
							scIdList.push(c.scId);
						})
					})
					getTextbookInfo(scIdList);
				};
			}, function(err) {
			})
		}

		function getTextbookInfo(scIdList) {
			Tasks.getTeacherBookDetailByScId(tea.id, scIdList, tea.token).then(function(data) {
				if (data.hasBookAnySC) {	// 已设置教材
					var bookdata = Resources.getChoosedBook();
					if (bookdata) {
						$state.go('tab.units');
					} else {
						$state.go('tab.books', {
							condition: 'nomal'
						});
					}
				} else {	// 未设置教材
					if ($scope.notextbookModal) {
						$scope.notextbookModal.show();
					};
				};
			}, function(err) {

			});
		}

		$scope.retry = function() {
			$scope.init();
		}

		$scope.assignHW = function() {
			getClassesInfo();
		}

		$scope.getTaskStatusName = function(status) {
			var name = '';
			if (status == Config.taskStatus.doing) {
				name = '进行中';
			} else if (status == Config.taskStatus.done) {
				name = '已截止';
			} else if (status == Config.taskStatus.todo) {
				name = '未开始';
			} else if (status == Config.taskStatus.unconfirm) {
				name = '待认领';
			};
			return name;
		}

		$scope.hideNoClassModal = function() {
			if ($scope.noclassModal) {
				$scope.noclassModal.hide();
			};
		}

		$scope.hideNoTextbookModal = function() {
			if ($scope.notextbookModal) {
				$scope.notextbookModal.hide();
			};
		}

		$scope.getCurrClassName = function() {
			if ($scope.currClassName) {
				return $scope.currClassName.replace('<div>', '').replace('</div>', '');
			} else {
				return '';
			};
		}

		$ionicModal.fromTemplateUrl('tmpl/tasks/noclass.html', {
			scope: $scope,
			hardwareBackButtonClose: true
		}).then(function(modal) {
			$scope.noclassModal = modal;
		});

		$ionicModal.fromTemplateUrl('tmpl/tasks/notextbook.html', {
			scope: $scope,
			hardwareBackButtonClose: true
		}).then(function(modal) {
			$scope.notextbookModal = modal;
		});
	})
})