define(['./module'], function(module) {

	module.directive('chartsPie', [function() {
		return {
			restrict: 'E',
			templateUrl: 'tmpl/widgets/common/charts-pie.html',
			replace: true,
			scope: {
				data: '@'
			},
			controller: function($scope, $element, $timeout) {

				var pdom = $element[0].getElementsByClassName('charts-pie')[0];
				pdom.style.width = '100%';
				pdom.style.height = '100%';
				var avgChart = echarts.init(pdom); 
				avgChart.showLoading({
					text: '加载中...'
				});

				$scope.$watch('data', function(data) {
					if (!data) return;

					var pie = $scope.pie = JSON.parse(data);
					avgChart.hideLoading();
					if (pie.nodata) return;

					avgChart.setOption({
						tooltip : {
							show: false
						},
						legend: {
							show: false,
							y : 'bottom',
							padding: 8,
							itemGap: 10,
							itemWidth: 12,
							textStyle: {fontSize: 8},
							data:pie.data
						},
						toolbox: {
							show : false
						},
						series : [
							{
								name:pie.title,
								type:'pie',
								radius : ['35%', '54%'],
								clickable: false,
								itemStyle : {
									normal : {
										color: function(args) {
											return pie.data[args.dataIndex]['color'];
										},
										label : {
											show : false
										},
										labelLine : {
											show : false
										}
									}
								},
								data:pie.data
							}
						]
					})
				})
			}
		}
	}])
})