define(['./module'], function(module) {

	module.directive('circle', [function() {
		return {
			restrict: 'E',
			templateUrl: 'tmpl/widgets/common/circle.html',
			replace: true,
			scope: {
				score: '@'
			},
			controller: function($scope, $element, $timeout) {
				$scope.$watch('score', function(score) {
					if (score) {
						if (score == '-') score = 0;

						var canvas = $element[0].getElementsByClassName('circle-canvas')[0];
						var ctx = canvas.getContext('2d');
						var angle = Math.round(score * 360 / 100);

						drawCircle(ctx, angle);
					}
				})

			}
		}
	}])

	function drawCircle(ctx, angle) {
		var i = 0, arc = 0, speed = Math.ceil(angle / 20), stopLoop = false;

		if (angle < 0) angle = 0;
		else if (angle > 360) angle = 360;

		requestAnimationFrame(loop);

		function loop() {
			i += speed;
			if (i >= angle) {
				i = angle;
				stopLoop = true;
			}

			ctx.clearRect(0, 0, 161, 161);

			ctx.save();
			ctx.beginPath();
			ctx.strokeStyle = 'rgba(0,0,0,.06)';
			ctx.lineWidth = 10;
			ctx.lineCap = 'round';
			ctx.arc(81, 81, 75, 0, Math.PI * 2, true);
			ctx.stroke();
			ctx.closePath();
			ctx.restore();

			ctx.save();
			ctx.beginPath();
			ctx.strokeStyle = '#fff';
			ctx.lineWidth = 10;
			ctx.lineCap = 'round';
			if (i === 0) arc = (270 - 360) * Math.PI / 180;
			else if (i === 360) arc = (270 - 0) * Math.PI / 180;
			else arc = (270 - i) * Math.PI / 180;
			ctx.arc(81, 81, 75, -Math.PI / 2, arc, true);
			ctx.stroke();
			ctx.closePath();
			ctx.restore();

			!stopLoop && requestAnimationFrame(loop);
		}
	}
})