define(['./module', 'moment'], function(module, moment) {

	module

	.filter('toDate', function() {
		return function(dateStr) {
			return moment(dateStr).format('YYYY-MM-DD')
		}
	})

	.filter('toDateWithoutSecond', function() {
		return function(dateStr) {
			return moment(dateStr).format('YYYY-MM-DD HH:mm')
		}
	})

	.filter('diffNow', function() {
		return function(dateStr) {
			return moment(dateStr).fromNow();
		}
	})

	moment.locale('cn', {
		months: [1,2,3,4,5,6,7,8,9,10,11,12],
		weekdays: ['周日','周一','周二','周三','周四','周五','周六'],
		relativeTime : {
			future: "%s内",
			past:   "%s 前",
			s:  "秒",
			m:  "1分",
			mm: "%d 分",
			h:  "1小时",
			hh: "%d 小时",
			d:  "1天",
			dd: "%d 天",
			M:  "1月",
			MM: "%d 月",
			y:  "1年",
			yy: "%d 年"
		}
	});
})