define(['./module'], function(module) {

	module.factory('Notices', function($q, $http, Config) {
		return {
			notices: [],

			getTeaNoticesByPage: function(teaId, page, row, token) {
				var q = $q.defer();
				var self = this;
				$http.post(Config.httpUrl + '/Notices/getTeaNoticesByPage', {
					teacherId: teaId,
					page: page,
					row: row,
					token: token
				}).success(function(data) {
					if (Config.checkStatus(data.status)) {	// 成功
						if (page == 1) {
							self.notices = data.data;
						} else {
							self.notices = self.notices.concat(data.data);
						}
						q.resolve(data.data);
					}
				}).error(function(err) {
					q.reject(err);
				})
				return q.promise;
			},
			getNoticeById: function(id) {
				var notice;
				this.notices.forEach(function(item) {
					if (item.id == id) notice = item;
				})
				return notice;
			},
			getTeaNoticeDetail: function(noticeId, teacherId, token) {
				var q = $q.defer();
				$http.post(Config.httpUrl + '/Notices/getTeaNoticeDetail', {
					noticeId: noticeId,
					teacherId: teacherId,
					token: token
				}).success(function(data) {
					q.resolve(data.data.notices);
				}).error(function(err) {
					q.reject(err);
				})
				return q.promise;
			},
			readOneNotice: function(teacherId, noticeId, token) {
				var q = $q.defer();
				$http.post(Config.httpUrl + '/notices/setNoticeStatusWithTeacher', {
					teacherId: teacherId,
					noticeId: noticeId,
					token: token
				}).success(function(data) {
					if (Config.checkStatus(data.status)) {
						q.resolve();
					}
				})
				return q.promise;
			},
			getNoticeStatus: function(teacherId, token) {
				var q = $q.defer();
				$http.post(Config.httpUrl + '/Notices/getTeaNewNoticesNum', {
					teacherId: teacherId,
					token: token
				}).success(function(data) {
					if (Config.checkStatus(data.status)) {
						q.resolve(data.data);
					}
				})
				return q.promise;
			},
			setAllNoticeReadedByTeacherId: function(teacherId, token) {
				var q = $q.defer();
				$http.post(Config.httpUrl + '/notices/setAllNoticeReadedByTeacherId', {
					teacherId: teacherId,
					token: token
				}).success(function(data) {
					if (Config.checkStatus(data.status)) {
						q.resolve(data.data);
					}
				})
				return q.promise;
			}
		}
	})
})