define(['./module'], function(module) {

    module.factory('Teachers', function($q, $http, $localStorage, $timeout, Config, AIEngine, Tasks) {
        return {
            activated: false,
            loginedManually: false, // 默认是false

            login: function(user) { // ch_dj    123
                var q = $q.defer();
                $http.post(Config.httpUrl + '/teachers/login', user).success(function(data) {
                    q.resolve(data);
                }).error(function(err) {
                    q.reject(err);
                });
                return q.promise;
            },
            logout: function() {
                this.reset();
            },
            activate: function() {
                var q = $q.defer();
                var self = this;
                // 初始化语音引擎
                AIEngine.init($localStorage.teacher.code.replace(/-/g, '')).then(function(result) {
                    // 初始化成功
                    console.log('------------ initSuccess', result)
                    q.resolve(true);
                    self.activated = true;
                }, function(err) {
                    console.log('------------ initFailed', err)
                    q.reject(err);
                });
                return q.promise;
            },
            reset: function() {
                delete $localStorage.teacher;
                delete $localStorage.user;
                delete $localStorage.choosedBook;
                delete $localStorage.preLoad;
                this.loginedManually = false;
                Tasks.taskCache = {};
            },
            get: function() {
                return $localStorage.teacher;
            },
            save: function(data) {
                $localStorage.teacher = data;
                $localStorage.hasShownGuided = true;
            },
            isLogin: function() {
                return !!$localStorage.teacher;
            },
            logged: function(user) {
                if (!$localStorage.users)
                    $localStorage.users = {};
                $localStorage.users[user.username] = true;
            },
            isLoggedBefore: function(user) {
                console.log('44444444444', user, $localStorage.users)
                return $localStorage.users && $localStorage.users[user.username];
            },
            isActived: function() {
                return this.activated;
            },
            setLoginedManually: function(flag) {
                this.loginedManually = flag;
            },
            isLoginedManually: function() {
                return this.loginedManually;
            },
            saveUser: function(user) {
                $localStorage.user = user;
            },
            getUser: function() {
                return $localStorage.user;
            },
            preLoad: function(params) {
                var q = $q.defer();
                var that = this;
                $http.post(Config.preLoadUrl + '/PreLanding/teacherPreLogin', params).success(function(data) {
                    that.savePreLoad(data.data);
                    q.resolve(data.data);
                }).error(function(err) {
                    q.reject(err);
                });
                return q.promise;
            },
            savePreLoad: function(data) {
                $localStorage.preLoad = data;
            },
            getPreLoad: function() {
                return $localStorage.preLoad;
            }
        }
    })
})