define([
	'./module',
	
	'./Config',
	'./AssignSucc',
	'./MobileVersions',
	'./Notices',
	'./PlatformUtil',
	'./Resources',
	'./Tasks',
	'./Teachers',
	'./Feedback'
], function(module) {

	module.factory('serviceInjector', ['$q', 'Toast', 'Config', function($q, Toast, Config) {
		return {
			request: function(httpCnf) {
				if (httpCnf.method == 'GET') console.log('AJAX', httpCnf.method, httpCnf.url);
				else console.log('AJAX', httpCnf.method, httpCnf.url.substring(Config.httpUrl.length), httpCnf.data);
				httpCnf.timeout = Config.timeout;
				return httpCnf;
			},
			response: function(httpRes) {
				if (httpRes.config.method == 'POST') {
					console.log('AJAX', 'RESPONSE', httpRes.config.url.substring(Config.httpUrl.length), httpRes.data);
					if (!httpRes.data || httpRes.data.status !== 1) {
						if (httpRes.data.status !== -1) {
							Toast.show(httpRes.data.info || Config.httpErrMsg);
						};

						return $q.reject({data: httpRes.data});
					}
				}
				return httpRes;
			},
			requestError: function(rejectReason) {
				console.log('AJAX REQ ERR', rejectReason);
				return $q.reject(rejectReason);
			},
			responseError: function(rejection) {
				console.log('AJAX RES ERR', rejection);
				Toast.show(Config.timeoutTip);
				return $q.reject({
					data: {
						status: -1, // 网络错误
						data: rejection
					}
				});
			}
		}
	}])

	module.config(['$httpProvider',function($httpProvider) {
		$httpProvider.interceptors.push('serviceInjector');
	}])

})
