[ngCordova](http://ngcordova.com/)
==========

[![Travis](http://img.shields.io/travis/driftyco/ng-cordova.svg?style=flat)](https://travis-ci.org/driftyco/ng-cordova) [![Bower](http://img.shields.io/badge/bower-ngCordova-FFCC2F.svg?style=flat)](http://bower.io/search/?q=ngCordova)

### Cordova with AngularJS Goodness


[<img src="http://ionicframework.com/img/ngcordova-context-logo.png" alt="ngCordova Logo" width="210px" height="210px" />](http://ngcordova.com/)


ngCordova gives you simple AngularJS wrappers for a massive amount of Cordova plugins. Check out the list below for all of the available plugins, and create an issue for a new request.

Created by the [Ionic Framework](http://ionicframework.com/) team and the community.

| RESOURCE | LINK |
|------------|---------|
| **Website** | [ngCordova.com](http://ngcordova.com/) |
| **Docs** | [ngCordova.com/docs](http://ngcordova.com/docs) |
| **Requirements** | [AngularJS](https://github.com/angular/angular.js),  [Cordova](http://cordova.apache.org/) |
| **Install** | `bower install ngCordova` or [download zip file](https://github.com/driftyco/ng-cordova/archive/master.zip) |
| **Custom build** | [ngCordova.com/build](http://ngcordova.com/build/) |


## Installation

Install manually, or from bower:

```bash
$ bower install ngCordova
```

## Plugins `(63+)`

- [Action Sheet](https://github.com/EddyVerbruggen/cordova-plugin-actionsheet)
- [AdMob](https://github.com/floatinghotpot/cordova-plugin-admob)
- [App Availability](https://github.com/ohh2ahh/AppAvailability)
- [App Preferences](https://github.com/dferrell/plugins-application-preferences)
- [App Rate](https://github.com/pushandplay/cordova-plugin-apprate)
- [App Version](https://github.com/whiteoctober/cordova-plugin-app-version)
- [Background Geolocation](https://github.com/christocracy/cordova-plugin-background-geolocation)
- [Badge](https://github.com/katzer/cordova-plugin-badge)
- [Barcode Scanner](https://github.com/wildabeast/BarcodeScanner)
- [Battery Status](https://github.com/apache/cordova-plugin-battery-status) *
- [Bluetooth Low Energy](https://github.com/evothings/cordova-ble)
- [Bluetooth Serial](https://github.com/don/BluetoothSerial)
- [Brightness](https://github.com/fiscal-cliff/phonegap-plugin-brightness)
- [Calendar](https://github.com/EddyVerbruggen/Calendar-PhoneGap-Plugin)
- [Camera](https://github.com/apache/cordova-plugin-camera) *
- [Clipboard](https://github.com/VersoSolutions/CordovaClipboard)
- [Console](https://github.com/apache/cordova-plugin-console) *
- [Contacts](https://github.com/apache/cordova-plugin-contacts) *
- [Date Picker](https://github.com/VitaliiBlagodir/cordova-plugin-datepicker)
- [Device Motion](https://github.com/apache/cordova-plugin-device-motion) *
- [Device Orientation](https://github.com/apache/cordova-plugin-device-orientation) *
- [Device](https://github.com/apache/cordova-plugin-device) *
- [Dialogs](https://github.com/apache/cordova-plugin-dialogs) *
- [Email Composer](https://github.com/katzer/cordova-plugin-email-composer)
- [Facebook Connect](https://github.com/Wizcorp/phonegap-facebook-plugin)
- [Facebook AudienceNetwork Ads](https://github.com/floatinghotpot/cordova-plugin-facebookads)
- [File](https://github.com/apache/cordova-plugin-file) *
- [File Transfer](https://github.com/apache/cordova-plugin-file-transfer) *
- [Flashlight](https://github.com/EddyVerbruggen/Flashlight-PhoneGap-Plugin)
- [Flurry Ads](https://github.com/floatinghotpot/cordova-plugin-flurry)
- [Geolocation](https://github.com/apache/cordova-plugin-geolocation) *
- [Globalization](https://github.com/apache/cordova-plugin-globalization) *
- [Google Ads](https://github.com/floatinghotpot/cordova-admob-pro)
- [Google Analytics](https://github.com/danwilson/google-analytics-plugin)
- [HealthKit for iOS](https://github.com/Telerik-Verified-Plugins/HealthKit)
- [Httpd (Web Server)](https://github.com/floatinghotpot/cordova-httpd)
- [Apple iAd](https://github.com/floatinghotpot/cordova-iad-pro)
- [Image Picker](https://github.com/wymsee/cordova-imagePicker)
- [InAppBrowser](https://github.com/apache/cordova-plugin-inappbrowser)*
- [Keyboard](https://github.com/driftyco/ionic-plugins-keyboard)
- [Keychain](https://github.com/shazron/KeychainPlugin)
- [Local Notifications](https://github.com/katzer/cordova-plugin-local-notifications/)
- [Media Capture](https://github.com/apache/cordova-plugin-media-capture)
- [Media](https://github.com/apache/cordova-plugin-media) *
- [MillennialMedia Ads](https://github.com/floatinghotpot/cordova-plugin-mmedia)
- [MobFox Ads](https://github.com/floatinghotpot/cordova-mobfox-pro)
- [MoPub Ads](https://github.com/floatinghotpot/cordova-plugin-mopub)
- [Native Audio](https://github.com/SidneyS/cordova-plugin-nativeaudio)
- [Network Information](https://github.com/apache/cordova-plugin-network-information) *
- [Oauth](https://github.com/nraboy/ng-cordova-oauth)
- [Pin Dialog](https://github.com/Paldom/PinDialog)
- [Printer](https://github.com/katzer/cordova-plugin-printer)
- [Progress Indicator](https://github.com/pbernasconi/cordova-progressIndicator)
- [Push Notifications](https://github.com/phonegap-build/PushPlugin)
- [SMS](https://github.com/aharris88/phonegap-sms-plugin)
- [Social Sharing](https://github.com/EddyVerbruggen/SocialSharing-PhoneGap-Plugin)
- [Spinner Dialog](https://github.com/Paldom/SpinnerDialog)
- [Splashscreen](https://github.com/apache/cordova-plugin-splashscreen) *
- [SQLite](https://github.com/brodysoft/Cordova-SQLitePlugin)
- [StatusBar](https://github.com/apache/cordova-plugin-statusbar) *
- [Toast](https://github.com/EddyVerbruggen/Toast-PhoneGap-Plugin)
- [Touchid](https://github.com/leecrossley/cordova-plugin-touchid)
- [Vibration](https://github.com/apache/cordova-plugin-vibration) *
- [Video Capture Plus](https://github.com/EddyVerbruggen/VideoCapturePlus-PhoneGap-Plugin) *
- [Zip](https://github.com/MobileChromeApps/zip)

`* official Apache Cordova Plugin`

## Authors

#### Max Lynch

- https://twitter.com/maxlynch
- https://github.com/mlynch

#### Paolo Bernasconi

- https://twitter.com/paolobernasconi
- https://github.com/pbernasconi


## LICENSE

ngCordova is licensed under the MIT Open Source license. For more information, see the LICENSE file in this repository.
